// Here we avoid loading the header multiple times
#ifndef LAUNCHBUTTON_HEADER
#define LAUNCHBUTTON_HEADER
// We need the Plasma Applet headers
#include <QtDBus> 

#include <Plasma/Applet>
#include <Plasma/PushButton>

#include "ui_launchButtonConfig.h"

#define LAUNCHBUTTON_EXEC_TYPE_CUSTOM 1
#define LAUNCHBUTTON_EXEC_TYPE_LAUNCHER 2
#define LAUNCHBUTTON_EXEC_TYPE_DBUS 3

class QSizeF;

// Define our plasma Applet
class LaunchButton : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        LaunchButton(QObject *parent, const QVariantList &args);
        ~LaunchButton();

        // The paintInterface procedure paints the applet to screen
        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
        void init();
    public slots:
        void createConfigurationInterface(KConfigDialog *parent);
        void execute();
        void dbusConnect();
        void dbusUpdateObjects();
        void dbusUpdatePaths();
        void dbusUpdateFunctions();
        void dbusUpdatedObject();
        void dbusUpdatedPath();
    protected slots:
        void configAccepted();
    protected:
        void constraintsEvent(Plasma::Constraints constraints);
        void dbusAddPaths(QString path);
        void dbusAddMethods(QString iface);
    private:
        Plasma::PushButton m_button;
        Ui::launchButtonConfig ui;

        QString m_displayImage;

        int m_execType;
        QString m_customCommand;
        QString m_launcherCommand;
        QString m_dbusObject;
        QString m_dbusPath;
        QString m_dbusFunction;
        QString m_dbusArgs;

        bool m_useFileDialog;
        QString m_startingPath;
        QString m_fileFilter;

        QDBusConnection m_dbusConnection;
};
 
// This is the command that links your applet to the .desktop file
K_EXPORT_PLASMA_APPLET(launchbutton, LaunchButton)
#endif
